import { ref as v, computed as b, watch as A, onMounted as xa, onBeforeUnmount as La, openBlock as C, createElementBlock as q, normalizeStyle as J, normalizeClass as ka, createBlock as F, createCommentVNode as _, unref as D, createSlots as Ca, withCtx as m, renderSlot as x, normalizeProps as B, guardReactiveProps as X, createElementVNode as K, createVNode as wa, toDisplayString as Ve, createTextVNode as Sa } from "vue";
import { u as $a, c as za, t as Ta, a as Ma, p as H, b as Ra, C as xe, i as Q, f as ee, Y as Ia, I as Oa, d as je, a2 as Pa, o as Fa, e as Ea, x as qe, y as Na, q as Aa, r as _a, s as ae, l as Da } from "./index-CWlhzm6K.js";
import { d as Ha, c as Wa, a as Je, t as Ya, l as w, r as Le, b as E, p as Ke, u as Ba } from "./useResponsive-CoxXLe23.js";
import { _ as Xa } from "./Tooltip-CUGz5S0n.js";
import { L as Ua } from "./Legend-BItqGLYs.js";
import { _ as Za } from "./Title-ZcAPoasN.js";
import { S as Ga } from "./Slicer-1C1usd0L.js";
import { u as Va, U as ja } from "./usePrinter-DPAte4qe.js";
import qa from "./vue-ui-accordion-DOBaAopj.js";
import { D as Ja } from "./DataTable-DpgVCStr.js";
import Ka from "./vue-ui-skeleton-D8lu0qH2.js";
import { u as Qe } from "./useNestedProp-DH41HJ08.js";
import { P as Qa } from "./PenAndPaper-CCFQ3lIj.js";
import { _ as el } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const al = ["id"], ll = ["onClick"], tl = {
  key: 2,
  class: "vue-data-ui-watermark"
}, ol = ["innerHTML"], ul = {
  __name: "vue-ui-xy-canvas",
  props: {
    dataset: {
      type: Array,
      default() {
        return [];
      }
    },
    config: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  emits: ["selectLegend"],
  setup(ke, { expose: ea, emit: aa }) {
    const M = ke, { vue_ui_xy_canvas: la } = $a(), ie = v(za()), U = v(null), $ = v(null), Z = v(null), s = v(null), f = v(1), R = v(1), le = v(!1), d = v(null), te = v(""), Ce = v(null), S = v([]), W = v(1), N = v(!0), z = v(!0), ve = v(null), we = v(0), Se = v(0), ce = v(!1), $e = v(null), ze = v(null), Te = v(null), Me = v(null), de = v(0), he = v(0), fe = v(0), ye = b(() => !!M.dataset && M.dataset.length), a = b({
      get: () => Re(),
      set: (e) => e
    });
    function Re() {
      const e = Qe({
        userConfig: M.config,
        defaultConfig: la
      });
      return e.theme ? {
        ...Qe({
          userConfig: Ta.vue_ui_xy_canvas[e.theme] || M.config,
          defaultConfig: e
        }),
        customPalette: Ma[e.theme] || H
      } : e;
    }
    A(() => M.config, (e) => {
      a.value = Re(), pe(), de.value += 1, he.value += 1, fe.value += 1;
    }, { deep: !0 }), A(() => M.dataset, () => {
      pe(), de.value += 1, he.value += 1, fe.value += 1;
    }, { deep: !0 });
    const Ie = v(a.value.style.chart.aspectRatio), { isPrinting: Oe, isImaging: Pe, generatePdf: Fe, generateImage: Ee } = Va({
      elementId: `xy_canvas_${ie.value}`,
      fileName: a.value.style.chart.title.text || "vue-ui-xy-canvas"
    }), r = v({
      showTable: a.value.table.show,
      showDataLabels: a.value.style.chart.dataLabels.show,
      stacked: a.value.style.chart.stacked,
      showTooltip: a.value.style.chart.tooltip.show
    });
    function ta(e) {
      ce.value = e, Se.value += 1;
    }
    const Ne = b(() => Ra(a.value.customPalette)), I = b(() => Y.value ? Math.max(...Y.value.filter((e, t) => !S.value.includes(e.absoluteIndex)).map((e) => e.series.length)) : 0), l = b(() => {
      const e = f.value - f.value * (a.value.style.chart.paddingProportions.left + a.value.style.chart.paddingProportions.right);
      return {
        canvasWidth: f.value,
        canvasHeight: R.value,
        left: f.value * a.value.style.chart.paddingProportions.left,
        top: R.value * a.value.style.chart.paddingProportions.top,
        right: f.value - f.value * a.value.style.chart.paddingProportions.right,
        bottom: R.value - R.value * a.value.style.chart.paddingProportions.bottom,
        width: e,
        height: R.value - R.value * (a.value.style.chart.paddingProportions.top + a.value.style.chart.paddingProportions.bottom),
        slot: e / (u.value.end - u.value.start)
      };
    });
    function Ae(e, t) {
      return e / t;
    }
    function oa({ hasAutoScale: e, series: t, min: o, max: i, scale: c, yOffset: y, individualHeight: n, stackIndex: g = null }) {
      return t.map((k, be) => {
        const T = c.min < 0 ? Math.abs(c.min) : 0, O = Ae(k + T, T + c.max);
        let P, G;
        e && (P = Math.abs(c.min), G = Ae(k + P, c.max + P));
        let V = 0;
        return g === null ? V = l.value.bottom - l.value.height * (e ? G : O) : V = l.value.bottom - y - n * (e ? G : O), {
          x: l.value.left + l.value.slot * be + l.value.slot / 2,
          y: V,
          value: k
        };
      });
    }
    const p = b(() => {
      const e = a.value.style.chart.scale.min !== null ? a.value.style.chart.scale.min : Math.min(...Y.value.filter((n, g) => !S.value.includes(n.absoluteIndex)).flatMap((n) => n.series.slice(u.value.start, u.value.end))), t = a.value.style.chart.scale.max !== null ? a.value.style.chart.scale.max : Math.max(...Y.value.filter((n, g) => !S.value.includes(n.absoluteIndex)).flatMap((n) => n.series.slice(u.value.start, u.value.end))), o = xe(e < 0 ? e : 0, t === e ? e + 1 < 0 ? 0 : e + 1 : t < 0 ? 0 : t, a.value.style.chart.scale.ticks), i = o.min < 0 ? Math.abs(o.min) : 0, c = l.value.bottom - l.value.height * (i / (o.max + i)), y = o.ticks.map((n) => ({
        y: l.value.bottom - l.value.height * ((n + i) / (o.max + i)),
        x: l.value.left - 8,
        value: n
      }));
      return {
        absoluteMin: i,
        max: t,
        min: e,
        scale: o,
        yLabels: y,
        zero: c
      };
    }), ua = b(() => h.value.map((e) => `
            <div style="display:flex;flex-direction:row;gap:6px;align-items:center;">
                <svg viewBox="0 0 10 10" height="12" width="12">
                    <circle cx="5" cy="5" r="5" fill="${e.color}"/>
                </svg>
                <span>${e.name ? e.name + ": " : ""}</span>
                <span>${Q(
      a.value.style.chart.dataLabels.formatter,
      e.series[d.value],
      ee({
        p: e.prefix || "",
        v: e.series[d.value],
        s: e.suffix || "",
        r: e.rounding || 0
      }),
      { datapoint: e, seriesIndex: d.value }
    )}</span>
            </div>
        `)), Y = b(() => M.dataset.map((e, t) => ({
      ...e,
      series: Ia({
        data: Oa(e.series),
        threshold: a.value.downsample.threshold
      }),
      absoluteIndex: t,
      color: je(e.color || Ne.value[t] || H[t] || H[t % H.length])
    })));
    A(I, (e) => {
      e && _e();
    });
    const h = b(() => Pa(Y.value.filter((e, t) => !S.value.includes(e.absoluteIndex))).map((e, t) => ({
      ...e,
      series: e.series.slice(u.value.start, u.value.end)
    })).map((e, t) => {
      let o = [null, void 0].includes(e.scaleMin) ? Math.min(...e.series) || 0 : e.scaleMin, i = [null, void 0].includes(e.scaleMax) ? Math.max(...e.series) || 1 : e.scaleMax;
      o === i && (o = o >= 0 ? i - 1 : o, i = i >= 0 ? i : o + 1);
      const y = {
        ratios: e.series.filter((j) => ![null, void 0].includes(j)).map((j) => (j - o) / (i - o)),
        valueMin: o,
        valueMax: i
      }, n = e.scaleSteps || a.value.style.chart.scale.ticks;
      let g;
      e.autoScaling ? g = xe(y.valueMin, y.valueMax, n) : g = xe(y.valueMin < 0 ? y.valueMin : 0, y.valueMax <= 0 ? 0 : y.valueMax, n);
      const k = r.value.stacked ? l.value.height * (1 - e.cumulatedStackRatio) : 0, be = r.value.stacked ? l.value.height / a.value.style.chart.stackGap : 0, T = r.value.stacked ? l.value.height * e.stackRatio - be : l.value.height, O = g.min < 0 ? Math.abs(g.min) : 0;
      let P;
      e.autoScaling && r.value.stacked && i <= 0 ? P = l.value.bottom - k - T : P = l.value.bottom - k - T * (O / (g.max + O));
      const G = g.ticks.map((j, ba) => ({
        y: l.value.bottom - k - T * (ba / (g.ticks.length - 1)),
        x: l.value.left - 8,
        value: j
      })), V = oa({
        hasAutoScale: r.value.stacked && e.autoScaling,
        series: e.series,
        min: r.value.stacked ? o : p.value.min,
        max: r.value.stacked ? i : p.value.max,
        scale: r.value.stacked ? g : p.value.scale,
        yOffset: k,
        individualHeight: T,
        stackIndex: r.value.stacked ? t : null
      });
      return {
        ...e,
        coordinatesLine: V,
        min: o,
        max: i,
        localScale: g,
        localZero: P,
        localMin: O,
        localYLabels: G,
        yOffset: k,
        individualHeight: T
      };
    })), u = v({
      start: 0,
      end: I.value
    });
    function _e() {
      u.value = {
        start: 0,
        end: I.value
      }, we.value += 1;
    }
    const ra = b(() => h.value.filter((e) => ["line", "plot", void 0].includes(e.type))), L = b(() => h.value.filter((e) => e.type === "bar"));
    function sa() {
      if (!$.value)
        return;
      const e = Z.value.offsetWidth, t = Z.value.offsetHeight;
      $.value.width = e * W.value * 2, $.value.height = t * W.value * 2, f.value = e * W.value * 2, R.value = t * W.value * 2, s.value.scale(W.value, W.value), ge();
    }
    function na() {
      if (s.value.clearRect(0, 0, 1e4, 1e4), s.value.fillStyle = a.value.style.chart.backgroundColor, s.value.fillRect(0, 0, l.value.canvasWidth, l.value.canvasHeight), r.value.stacked)
        a.value.style.chart.grid.y.verticalLines.show && u.value.end - u.value.start < a.value.style.chart.grid.y.verticalLines.hideUnderXLength && h.value.forEach((e) => {
          for (let t = 0; t < u.value.end - u.value.start + 1; t += 1)
            w(
              s.value,
              [
                {
                  x: l.value.left + l.value.slot * t,
                  y: l.value.bottom - e.yOffset - e.individualHeight
                },
                {
                  x: l.value.left + l.value.slot * t,
                  y: l.value.bottom - e.yOffset
                }
              ],
              {
                color: a.value.style.chart.grid.y.verticalLines.color
              }
            );
        }), a.value.style.chart.grid.x.horizontalLines.show && (a.value.style.chart.grid.x.horizontalLines.alternate ? h.value.forEach((e) => {
          e.localYLabels.forEach((t, o) => {
            o < e.localYLabels.length - 1 && Le(
              s.value,
              [
                { x: l.value.left, y: t.y },
                { x: l.value.right, y: t.y },
                { x: l.value.right, y: e.localYLabels[o + 1].y },
                { x: l.value.left, y: e.localYLabels[o + 1].y }
              ],
              {
                fillColor: o % 2 === 0 ? "transparent" : ae(a.value.style.chart.grid.x.horizontalLines.color, a.value.style.chart.grid.x.horizontalLines.opacity),
                strokeColor: "transparent"
              }
            );
          });
        }) : h.value.forEach((e) => {
          e.localYLabels.slice(u.value.start, u.value.end).forEach((t) => {
            w(
              s.value,
              [
                { x: l.value.left, y: t.y },
                { x: l.value.right, y: t.y }
              ],
              {
                color: a.value.style.chart.grid.x.horizontalLines.color
              }
            );
          });
        })), a.value.style.chart.grid.zeroLine.show && h.value.forEach((e) => {
          w(
            s.value,
            [
              { x: l.value.left, y: e.localZero },
              { x: l.value.right, y: e.localZero }
            ],
            {
              color: a.value.style.chart.grid.zeroLine.color,
              lineDash: a.value.style.chart.grid.zeroLine.dashed ? [10, 10] : [0, 0]
            }
          );
        }), a.value.style.chart.grid.y.axisLabels.show && h.value.forEach((e) => {
          w(
            s.value,
            [
              { x: l.value.left, y: l.value.bottom - e.yOffset },
              { x: l.value.left, y: l.value.bottom - e.yOffset - e.individualHeight }
            ],
            {
              color: e.color
            }
          ), w(
            s.value,
            [
              { x: l.value.right, y: l.value.bottom - e.yOffset },
              { x: l.value.right, y: l.value.bottom - e.yOffset - e.individualHeight }
            ],
            {
              color: e.color
            }
          ), e.localYLabels.forEach((t, o) => {
            E(
              s.value,
              Q(
                a.value.style.chart.dataLabels.formatter,
                t.value,
                ee({
                  p: e.prefix || a.value.style.chart.grid.y.axisLabels.prefix || "",
                  v: t.value,
                  s: e.suffix || a.value.style.chart.grid.y.axisLabels.suffix || "",
                  r: e.rounding || a.value.style.chart.grid.y.axisLabels.rounding || 0
                }),
                { datapoint: t, seriesIndex: o }
              ),
              t.x + a.value.style.chart.grid.y.axisLabels.offsetX,
              t.y,
              {
                align: "right",
                font: `${Math.round(f.value / 40 * a.value.style.chart.grid.y.axisLabels.fontSizeRatio)}px ${a.value.style.fontFamily}`,
                color: e.color
              }
            );
          });
        }), h.value.forEach((e) => {
          E(
            s.value,
            e.name,
            f.value / 35,
            l.value.bottom - e.yOffset - e.individualHeight / 2,
            {
              align: "center",
              rotation: -90,
              color: e.color,
              font: `${Math.round(f.value / 40 * a.value.style.chart.grid.y.axisLabels.fontSizeRatio)}px ${a.value.style.fontFamily}`
            }
          );
        });
      else {
        if (a.value.style.chart.grid.y.verticalLines.show && u.value.end - u.value.start < a.value.style.chart.grid.y.verticalLines.hideUnderXLength)
          for (let e = 0; e < u.value.end - u.value.start + 1; e += 1)
            w(
              s.value,
              [
                { x: l.value.left + l.value.slot * e, y: l.value.top },
                { x: l.value.left + l.value.slot * e, y: l.value.bottom }
              ],
              {
                color: a.value.style.chart.grid.y.verticalLines.color
              }
            );
        a.value.style.chart.grid.x.horizontalLines.show && (a.value.style.chart.grid.x.horizontalLines.alternate ? p.value.yLabels.forEach((e, t) => {
          t < p.value.yLabels.length - 1 && Le(
            s.value,
            [
              { x: l.value.left, y: e.y },
              { x: l.value.right, y: e.y },
              { x: l.value.right, y: p.value.yLabels[t + 1].y },
              { x: l.value.left, y: p.value.yLabels[t + 1].y }
            ],
            {
              fillColor: t % 2 === 0 ? "transparent" : ae(a.value.style.chart.grid.x.horizontalLines.color, a.value.style.chart.grid.x.horizontalLines.opacity),
              strokeColor: "transparent"
            }
          );
        }) : p.value.yLabels.forEach((e) => {
          w(
            s.value,
            [
              { x: l.value.left, y: e.y },
              { x: l.value.right, y: e.y }
            ],
            {
              color: a.value.style.chart.grid.x.horizontalLines.color
            }
          );
        })), a.value.style.chart.grid.y.showAxis && w(
          s.value,
          [
            { x: l.value.left, y: l.value.top },
            { x: l.value.left, y: l.value.bottom }
          ],
          {
            color: a.value.style.chart.grid.y.axisColor,
            lineWidth: a.value.style.chart.grid.y.axisThickness
          }
        ), a.value.style.chart.grid.x.showAxis && w(
          s.value,
          [
            { x: l.value.left, y: l.value.bottom },
            { x: l.value.right, y: l.value.bottom }
          ],
          {
            color: a.value.style.chart.grid.x.axisColor,
            lineWidth: a.value.style.chart.grid.x.axisThickness
          }
        ), a.value.style.chart.grid.zeroLine.show && w(
          s.value,
          [
            { x: l.value.left, y: p.value.zero },
            { x: l.value.right, y: p.value.zero }
          ],
          {
            color: a.value.style.chart.grid.zeroLine.color,
            lineDash: a.value.style.chart.grid.zeroLine.dashed ? [10, 10] : [0, 0]
          }
        ), a.value.style.chart.grid.y.axisLabels.show && p.value.yLabels.forEach((e, t) => {
          E(
            s.value,
            Q(
              a.value.style.chart.dataLabels.formatter,
              e.value,
              ee({
                p: a.value.style.chart.grid.y.axisLabels.prefix || "",
                v: e.value,
                s: a.value.style.chart.grid.y.axisLabels.suffix || "",
                r: a.value.style.chart.grid.y.axisLabels.rounding || 0
              }),
              { datapoint: e, seriesIndex: t }
            ),
            e.x + a.value.style.chart.grid.y.axisLabels.offsetX,
            e.y,
            {
              align: "right",
              font: `${Math.round(f.value / 40 * a.value.style.chart.grid.y.axisLabels.fontSizeRatio)}px ${a.value.style.fontFamily}`,
              color: a.value.style.chart.grid.y.axisLabels.color
            }
          );
        });
      }
      a.value.style.chart.grid.y.axisName && E(
        s.value,
        a.value.style.chart.grid.y.axisName,
        f.value - f.value / 40 * a.value.style.chart.grid.y.axisLabels.fontSizeRatio * 1.2,
        l.value.bottom - l.value.height / 2,
        {
          font: `${Math.round(f.value / 40 * a.value.style.chart.grid.y.axisLabels.fontSizeRatio)}px ${a.value.style.fontFamily}`,
          color: a.value.style.chart.color,
          align: "center",
          rotation: 90
        }
      ), a.value.style.chart.grid.x.axisName && E(
        s.value,
        a.value.style.chart.grid.x.axisName,
        f.value / 2,
        R.value,
        {
          font: `${Math.round(f.value / 40 * a.value.style.chart.grid.y.axisLabels.fontSizeRatio)}px ${a.value.style.fontFamily}`,
          color: a.value.style.chart.color,
          align: "center"
        }
      );
    }
    function ia(e) {
      for (let t = 0; t < e.coordinatesLine.length; t += 1) {
        const o = (d.value === t ? f.value / 150 : a.value.style.chart.line.plots.show ? f.value / 200 : 0) * a.value.style.chart.line.plots.radiusRatio;
        Je(
          s.value,
          { x: e.coordinatesLine[t].x, y: e.coordinatesLine[t].y },
          o,
          {
            color: a.value.style.chart.backgroundColor,
            fillStyle: e.color,
            strokeColor: "transparent"
          }
        );
      }
    }
    function va(e) {
      for (let t = 0; t < e.coordinatesLine.length; t += 1)
        E(
          s.value,
          Q(
            a.value.style.chart.dataLabels.formatter,
            e.coordinatesLine[t].value,
            ee({
              p: e.prefix || "",
              v: e.coordinatesLine[t].value,
              s: e.suffix || "",
              r: e.rounding || 0
            }),
            { datapoint: e.coordinatesLine[t], seriesIndex: t }
          ),
          e.coordinatesLine[t].x,
          e.coordinatesLine[t].y + a.value.style.chart.dataLabels.offsetY,
          {
            align: "center",
            font: `${Math.round(f.value / 40 * a.value.style.chart.dataLabels.fontSizeRatio)}px ${a.value.style.fontFamily}`,
            color: a.value.style.chart.dataLabels.useSerieColor ? e.color : a.value.style.chart.dataLabels.color,
            strokeColor: a.value.style.chart.backgroundColor,
            lineWidth: 0.8
          }
        );
    }
    function ca() {
      for (let e = u.value.start; e < u.value.end; e += 1)
        (u.value.end - u.value.start < a.value.style.chart.grid.y.timeLabels.modulo || u.value.end - u.value.start >= a.value.style.chart.grid.y.timeLabels.modulo && (e % Math.floor((u.value.end - u.value.start) / a.value.style.chart.grid.y.timeLabels.modulo) === 0 || e === d.value + u.value.start)) && E(
          s.value,
          a.value.style.chart.grid.y.timeLabels.values[e] || e + 1,
          l.value.left + l.value.slot * (e - u.value.start) + l.value.slot / 2,
          l.value.bottom + f.value / a.value.style.chart.grid.y.timeLabels.offsetY,
          {
            align: a.value.style.chart.grid.y.timeLabels.rotation === 0 ? "center" : a.value.style.chart.grid.y.timeLabels.rotation > 0 ? "left" : "right",
            font: `${Math.round(f.value / 40 * a.value.style.chart.grid.y.timeLabels.fontSizeRatio)}px ${a.value.style.fontFamily}`,
            color: ae(a.value.style.chart.grid.y.timeLabels.color, d.value !== null ? d.value + u.value.start === e ? 100 : 20 : 100),
            rotation: a.value.style.chart.grid.y.timeLabels.rotation
          }
        );
    }
    function De() {
      w(
        s.value,
        [
          { x: l.value.left + l.value.slot * d.value + l.value.slot / 2, y: l.value.top },
          { x: l.value.left + l.value.slot * d.value + l.value.slot / 2, y: l.value.bottom }
        ],
        {
          color: a.value.style.chart.selector.color,
          lineDash: a.value.style.chart.selector.dashed ? [8, 8] : [0, 0],
          lineWidth: 2,
          linceCap: "round"
        }
      );
    }
    function da() {
      L.value.forEach((e, t) => {
        for (let o = 0; o < e.coordinatesLine.length; o += 1)
          Le(
            s.value,
            [
              {
                x: l.value.left + l.value.slot * o + l.value.slot / 10 + (r.value.stacked ? 0 : l.value.slot / L.value.length * t - (t === 0 ? 0 : l.value.slot / (5 * L.value.length) * t)),
                y: r.value.stacked ? e.localZero : p.value.zero
              },
              {
                x: l.value.left + l.value.slot * o + l.value.slot / 10 + (r.value.stacked ? 0 : l.value.slot / L.value.length * t - (t === 0 ? 0 : l.value.slot / (5 * L.value.length) * t)) + l.value.slot * 0.8 / (r.value.stacked ? 1 : L.value.length),
                y: r.value.stacked ? e.localZero : p.value.zero
              },
              {
                x: l.value.left + l.value.slot * o + l.value.slot / 10 + (r.value.stacked ? 0 : l.value.slot / L.value.length * t - (t === 0 ? 0 : l.value.slot / (5 * L.value.length) * t)) + l.value.slot * 0.8 / (r.value.stacked ? 1 : L.value.length),
                y: e.coordinatesLine[o].y
              },
              {
                x: l.value.left + l.value.slot * o + l.value.slot / 10 + (r.value.stacked ? 0 : l.value.slot / L.value.length * t - (t === 0 ? 0 : l.value.slot / (5 * L.value.length) * t)),
                y: e.coordinatesLine[o].y
              }
            ],
            {
              strokeColor: a.value.style.chart.backgroundColor,
              gradient: {
                type: "linear",
                start: {
                  x: e.coordinatesLine[o].x,
                  y: e.coordinatesLine[o].y
                },
                end: {
                  x: e.coordinatesLine[o].x,
                  y: r.value.stacked ? e.localZero : p.value.zero
                },
                stops: [
                  { offset: 0, color: e.color },
                  { offset: 1, color: Da(e.color, 0.5) }
                ]
              }
            }
          ), r.value.showDataLabels && [!0, void 0].includes(e.dataLabels) && E(
            s.value,
            Q(
              a.value.style.chart.dataLabels.formatter,
              e.coordinatesLine[o].value,
              ee({
                p: e.prefix || "",
                v: e.coordinatesLine[o].value,
                s: e.suffix || "",
                r: e.rounding || 0
              }),
              { datapoint: e.coordinatesLine[o], seriesIndex: o }
            ),
            l.value.left + l.value.slot * o + l.value.slot / 10 + (r.value.stacked ? 0 : l.value.slot / L.value.length * t - (t === 0 ? 0 : l.value.slot / (5 * L.value.length) * t)) + l.value.slot * 0.4 / (r.value.stacked ? 1 : L.value.length),
            (e.coordinatesLine[o].value < 0 ? r.value.stacked ? e.localZero : p.value.zero : e.coordinatesLine[o].y) + a.value.style.chart.dataLabels.offsetY,
            {
              align: "center",
              font: `${Math.round(f.value / 40 * a.value.style.chart.dataLabels.fontSizeRatio)}px ${a.value.style.fontFamily}`,
              color: a.value.style.chart.dataLabels.useSerieColor ? e.color : a.value.style.chart.dataLabels.color,
              strokeColor: a.value.style.chart.backgroundColor,
              lineWidth: 0.8
            }
          );
      });
    }
    function ha(e) {
      e.useArea ? r.value.stacked ? Ke(
        s.value,
        [{ x: e.coordinatesLine[0].x, y: e.localZero }, ...e.coordinatesLine, { x: e.coordinatesLine.at(-1).x, y: e.localZero }],
        {
          fillColor: ae(e.color, a.value.style.chart.area.opacity),
          strokeColor: "transparent"
        }
      ) : Ke(
        s.value,
        [{ x: e.coordinatesLine[0].x, y: p.value.zero }, ...e.coordinatesLine, { x: e.coordinatesLine.at(-1).x, y: p.value.zero }],
        {
          fillColor: ae(e.color, a.value.style.chart.area.opacity),
          strokeColor: "transparent"
        }
      ) : w(s.value, e.coordinatesLine, {
        color: e.color,
        lineWidth: 3
      });
    }
    function fa() {
      h.value.forEach((e, t) => {
        w(
          s.value,
          [
            { x: l.value.left, y: l.value.bottom - e.yOffset },
            { x: l.value.right, y: l.value.bottom - e.yOffset }
          ],
          {
            color: a.value.style.chart.grid.x.horizontalLines.color,
            lineWidth: 1
          }
        );
      });
    }
    function ge() {
      na(), N.value ? (z.value && d.value !== null && a.value.style.chart.selector.show && De(), da(), r.value.stacked && a.value.style.chart.grid.x.showAxis && fa(), ra.value.forEach((e) => {
        (e.type === "line" || !e.type) && ha(e), z.value && (ia(e), r.value.showDataLabels && [!0, void 0].includes(e.dataLabels) && va(e));
      }), ve.value = Wa($.value)) : (ve.value && (s.value.clearRect(0, 0, 1e4, 1e4), s.value.drawImage(ve.value, 0, 0)), z.value && d.value !== null && a.value.style.chart.selector.show && De(), z.value && d.value !== null && h.value.forEach((e) => {
        if (e.type === "line" || !e.type || e.type === "plot") {
          if (!e.coordinatesLine[d.value]) return;
          e.coordinatesLine[d.value].x !== void 0 && e.coordinatesLine[d.value].y !== void 0 && Je(
            s.value,
            {
              x: e.coordinatesLine[d.value].x,
              y: e.coordinatesLine[d.value].y
            },
            f.value / 150 * a.value.style.chart.line.plots.radiusRatio,
            {
              color: a.value.style.chart.backgroundColor,
              fillStyle: e.color,
              strokeColor: "transparent"
            }
          );
        }
      })), a.value.style.chart.grid.y.timeLabels.show && ca(), N.value = !1;
    }
    const oe = Ha(() => {
      z.value = !0, sa();
    }, I.value > 200 ? 10 : 1, !z.value);
    function ya(e) {
      const { left: t } = $.value.getBoundingClientRect(), o = e.clientX - t;
      if (o * 2 < l.value.left || o * 2 > l.value.right) {
        le.value = !1, d.value = null;
        return;
      }
      const i = o * 2 - l.value.left;
      if (d.value = Math.floor(i / l.value.slot), le.value = !0, !z.value) return;
      let c = "";
      const y = a.value.style.chart.tooltip.customFormat;
      qe(y) && Na(() => y({
        seriesIndex: d.value,
        datapoint: h.value.map((n) => ({
          shape: n.shape || null,
          name: n.name,
          color: n.color,
          type: n.type || "line",
          value: n.series.find((g, k) => k === d.value)
        })),
        series: h.value,
        config: a.value
      })) ? te.value = y({
        seriesIndex: d.value,
        datapoint: h.value.map((n) => ({
          shape: n.shape || null,
          name: n.name,
          color: n.color,
          type: n.type || "line",
          value: n.series.find((g, k) => k === d.value)
        })),
        series: h.value,
        config: a.value
      }) : (a.value.style.chart.grid.y.timeLabels.values.slice(u.value.start, u.value.end)[d.value] && (c += `<div style="padding-bottom: 6px; margin-bottom: 4px; border-bottom: 1px solid ${a.value.style.chart.tooltip.borderColor}; width:100%">${a.value.style.chart.grid.y.timeLabels.values.slice(u.value.start, u.value.end)[d.value]}</div>`), c += ua.value.join(""), te.value = c), z.value = !1;
    }
    A(() => d.value, (e) => {
      oe();
    }), A(() => u.value, (e) => {
      N.value = !0, ge();
    }, {
      deep: !0
    }), A(() => r.value.showDataLabels, (e) => {
      N.value = !0, ge();
    }), A(() => r.value.stacked, (e) => {
      N.value = !0, z.value = !0, oe();
    });
    function ga() {
      le.value = !1, d.value = null, te.value = "";
    }
    const ue = v(null), re = v(null);
    xa(() => {
      pe();
    });
    function pe() {
      if (Fa(M.dataset) ? Ea({
        componentName: "VueUiXyCanvas",
        type: "dataset"
      }) : $.value && (s.value = $.value.getContext("2d", { willReadFrequently: !0 })), a.value.responsive) {
        const e = Ya(() => {
          const { width: t, height: o } = Ba({
            chart: U.value,
            title: a.value.style.chart.title.text ? $e.value : null,
            legend: a.value.style.chart.legend.show ? ze.value : null,
            slicer: a.value.style.chart.zoom.show && I.value > 1 ? Te.value : null,
            source: Me.value
          });
          Ie.value = `${t} / ${o}`;
        });
        ue.value = new ResizeObserver(e), ue.value.observe(U.value.parentNode);
      }
      re.value = new ResizeObserver((e) => {
        for (const t of e)
          t.contentBoxSize && Z.value && (N.value = !0, oe());
      }), re.value.observe(Z.value);
    }
    La(() => {
      re.value && re.value.disconnect(), ue.value && ue.value.disconnect();
    });
    function He(e) {
      aa("selectLegend", h.value.find((t) => t.absoluteIndex === e)), S.value.includes(e) ? S.value = S.value.filter((t) => t !== e) : S.value.push(e), N.value = !0, oe();
    }
    const We = b(() => Y.value.map((e, t) => ({
      ...e,
      name: e.name,
      color: je(e.color) || Ne.value[t] || H[t] || H[t % H.length],
      shape: e.shape || "circle",
      prefix: e.prefix || "",
      suffix: e.suffix || "",
      rounding: e.rounding || 0
    })).map((e) => ({
      ...e,
      opacity: S.value.includes(e.absoluteIndex) ? 0.5 : 1,
      segregate: () => He(e.absoluteIndex),
      isSegregated: S.value.includes(e.absoluteIndex)
    }))), pa = b(() => ({
      cy: "donut-div-legend",
      backgroundColor: a.value.style.chart.legend.backgroundColor,
      color: a.value.style.chart.legend.color,
      fontSize: a.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: a.value.style.chart.legend.bold ? "bold" : ""
    })), se = b(() => {
      const e = [""].concat(h.value.map((c) => c.name)).concat(' <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z" fill="none"/><path d="M18 16v2a1 1 0 0 1 -1 1h-11l6 -7l-6 -7h11a1 1 0 0 1 1 1v2" /></svg>');
      let t = [];
      for (let c = 0; c < I.value; c += 1) {
        const y = h.value.map((n) => n.series[c] ?? 0).reduce((n, g) => n + g, 0);
        t.push([a.value.style.chart.grid.y.timeLabels.values.slice(u.value.start, u.value.end)[c] ?? c + 1].concat(h.value.map((n) => (n.series[c] ?? 0).toFixed(a.value.table.rounding))).concat((y ?? 0).toFixed(a.value.table.rounding)));
      }
      const o = {
        th: {
          backgroundColor: a.value.table.th.backgroundColor,
          color: a.value.table.th.color,
          outline: a.value.table.th.outline
        },
        td: {
          backgroundColor: a.value.table.td.backgroundColor,
          color: a.value.table.td.color,
          outline: a.value.table.td.outline
        },
        breakpoint: a.value.table.responsiveBreakpoint
      }, i = [a.value.table.columnNames.period].concat(h.value.map((c) => c.name)).concat(a.value.table.columnNames.total);
      return { head: e, body: t.slice(0, u.value.end - u.value.start), config: o, colNames: i };
    }), Ye = b(() => {
      if (h.value.length === 0) return { head: [], body: [], config: {}, columnNames: [] };
      const e = h.value.map((o) => ({
        label: o.name,
        color: o.color,
        type: o.type
      })), t = [];
      for (let o = u.value.start; o < u.value.end; o += 1) {
        const i = [a.value.style.chart.grid.y.timeLabels.values[o] || o + 1];
        h.value.forEach((c) => {
          i.push(Number((c.series[o] || 0).toFixed(a.value.table.rounding)));
        }), t.push(i);
      }
      return { head: e, body: t };
    });
    function Be() {
      const e = [[a.value.style.chart.title.text], [a.value.style.chart.title.subtitle.text], [""]], t = ["", ...Ye.value.head.map((y) => y.label)], o = Ye.value.body, i = e.concat([t]).concat(o), c = Aa(i);
      _a({ csvContent: c, title: a.value.style.chart.title.text || "vue-ui-xy-canvas" });
    }
    function ma() {
      return h.value;
    }
    function Xe() {
      r.value.showTable = !r.value.showTable;
    }
    function Ue() {
      r.value.showDataLabels = !r.value.showDataLabels;
    }
    function Ze() {
      r.value.stacked = !r.value.stacked;
    }
    function Ge() {
      r.value.showTooltip = !r.value.showTooltip;
    }
    const ne = v(!1);
    function me() {
      ne.value = !ne.value;
    }
    return ea({
      getData: ma,
      generateCsv: Be,
      generatePdf: Fe,
      generateImage: Ee,
      toggleTable: Xe,
      toggleLabels: Ue,
      toggleStack: Ze,
      toggleTooltip: Ge,
      toggleAnnotator: me
    }), (e, t) => (C(), q("div", {
      style: J(`width:100%; position:relative; ${a.value.responsive ? "height: 100%" : ""}`),
      ref_key: "xy",
      ref: U,
      id: `xy_canvas_${ie.value}`,
      class: ka(`vue-ui-donut ${ce.value ? "vue-data-ui-wrapper-fullscreen" : ""}`)
    }, [
      a.value.style.chart.title.text ? (C(), q("div", {
        key: 0,
        ref_key: "chartTitle",
        ref: $e,
        style: J(`width:100%;background:${a.value.style.chart.backgroundColor};`)
      }, [
        (C(), F(Za, {
          key: `title_${de.value}`,
          config: {
            title: {
              cy: "xy-canvas-title",
              ...a.value.style.chart.title
            },
            subtitle: {
              cy: "xy-canvas-subtitle",
              ...a.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 4)) : _("", !0),
      a.value.userOptions.show && ye.value ? (C(), F(ja, {
        ref: "details",
        key: `user_option_${Se.value}`,
        backgroundColor: a.value.style.chart.backgroundColor,
        color: a.value.style.chart.color,
        isPrinting: D(Oe),
        isImaging: D(Pe),
        uid: ie.value,
        hasTooltip: a.value.userOptions.buttons.tooltip && a.value.style.chart.tooltip.show,
        hasPdf: a.value.userOptions.buttons.pdf,
        hasImg: a.value.userOptions.buttons.img,
        hasXls: a.value.userOptions.buttons.csv,
        hasLabel: a.value.userOptions.buttons.labels,
        hasStack: ke.dataset.length > 1 && a.value.userOptions.buttons.stack,
        hasFullscreen: a.value.userOptions.buttons.fullscreen,
        hasTable: u.value.end - u.value.start < 200 && a.value.userOptions.buttons.table,
        isFullscreen: ce.value,
        isTooltip: r.value.showTooltip,
        isStacked: r.value.stacked,
        titles: { ...a.value.userOptions.buttonTitles },
        chartElement: U.value,
        position: a.value.userOptions.position,
        hasAnnotator: a.value.userOptions.buttons.annotator,
        isAnnotation: ne.value,
        onToggleFullscreen: ta,
        onGeneratePdf: D(Fe),
        onGenerateCsv: Be,
        onGenerateImage: D(Ee),
        onToggleTable: Xe,
        onToggleLabels: Ue,
        onToggleStack: Ze,
        onToggleTooltip: Ge,
        onToggleAnnotator: me
      }, Ca({ _: 2 }, [
        e.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: m(() => [
            x(e.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        e.$slots.optionPdf ? {
          name: "optionPdf",
          fn: m(() => [
            x(e.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        e.$slots.optionCsv ? {
          name: "optionCsv",
          fn: m(() => [
            x(e.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        e.$slots.optionImg ? {
          name: "optionImg",
          fn: m(() => [
            x(e.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        e.$slots.optionTable ? {
          name: "optionTable",
          fn: m(() => [
            x(e.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        e.$slots.optionLabels ? {
          name: "optionLabels",
          fn: m(() => [
            x(e.$slots, "optionLabels", {}, void 0, !0)
          ]),
          key: "5"
        } : void 0,
        e.$slots.optionStack ? {
          name: "optionStack",
          fn: m(() => [
            x(e.$slots, "optionStack", {}, void 0, !0)
          ]),
          key: "6"
        } : void 0,
        e.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: m(({ toggleFullscreen: o, isFullscreen: i }) => [
            x(e.$slots, "optionFullscreen", B(X({ toggleFullscreen: o, isFullscreen: i })), void 0, !0)
          ]),
          key: "7"
        } : void 0,
        e.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: m(({ toggleAnnotator: o, isAnnotator: i }) => [
            x(e.$slots, "optionAnnotator", B(X({ toggleAnnotator: o, isAnnotator: i })), void 0, !0)
          ]),
          key: "8"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasImg", "hasXls", "hasLabel", "hasStack", "hasFullscreen", "hasTable", "isFullscreen", "isTooltip", "isStacked", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage"])) : _("", !0),
      K("div", {
        class: "vue-ui-xy-canvas",
        style: J(`position: relative; aspect-ratio: ${Ie.value}`),
        ref_key: "container",
        ref: Z
      }, [
        ye.value ? (C(), q("canvas", {
          key: 0,
          ref_key: "canvas",
          ref: $,
          style: { width: "100%", height: "100%" },
          onMousemove: t[0] || (t[0] = (o) => ya(o)),
          onMouseleave: ga
        }, null, 544)) : (C(), F(Ka, {
          key: 1,
          config: {
            type: "line",
            style: {
              backgroundColor: a.value.style.chart.backgroundColor,
              line: {
                axis: {
                  color: "#CCCCCC"
                },
                path: {
                  color: "#CCCCCC",
                  strokeWidth: 0.5
                }
              }
            }
          }
        }, null, 8, ["config"])),
        wa(Xa, {
          show: r.value.showTooltip && le.value,
          backgroundColor: a.value.style.chart.tooltip.backgroundColor,
          color: a.value.style.chart.tooltip.color,
          fontSize: a.value.style.chart.tooltip.fontSize,
          borderRadius: a.value.style.chart.tooltip.borderRadius,
          borderColor: a.value.style.chart.tooltip.borderColor,
          borderWidth: a.value.style.chart.tooltip.borderWidth,
          position: a.value.style.chart.tooltip.position,
          offsetY: a.value.style.chart.tooltip.offsetY,
          parent: $.value,
          content: te.value,
          backgroundOpacity: a.value.style.chart.tooltip.backgroundOpacity,
          isCustom: D(qe)(a.value.style.chart.tooltip.customFormat)
        }, {
          "tooltip-before": m(() => [
            x(e.$slots, "tooltip-before", B(X({ ...Ce.value })), void 0, !0)
          ]),
          "tooltip-after": m(() => [
            x(e.$slots, "tooltip-after", B(X({ ...Ce.value })), void 0, !0)
          ]),
          _: 3
        }, 8, ["show", "backgroundColor", "color", "fontSize", "borderRadius", "borderColor", "borderWidth", "position", "offsetY", "parent", "content", "backgroundOpacity", "isCustom"])
      ], 4),
      K("div", {
        ref_key: "chartSlicer",
        ref: Te,
        style: J(`width:100%;background:${a.value.style.chart.backgroundColor}`),
        "data-html2canvas-ignore": ""
      }, [
        a.value.style.chart.zoom.show && I.value > 1 ? (C(), F(Ga, {
          key: `slicer_${we.value}`,
          background: a.value.style.chart.zoom.color,
          borderColor: a.value.style.chart.backgroundColor,
          fontSize: a.value.style.chart.zoom.fontSize,
          useResetSlot: a.value.style.chart.zoom.useResetSlot,
          labelLeft: a.value.style.chart.grid.y.timeLabels.values[u.value.start] ? a.value.style.chart.grid.y.timeLabels.values[u.value.start] : "",
          labelRight: a.value.style.chart.grid.y.timeLabels.values[u.value.end - 1] ? a.value.style.chart.grid.y.timeLabels.values[u.value.end - 1] : "",
          textColor: a.value.style.chart.color,
          inputColor: a.value.style.chart.zoom.color,
          selectColor: a.value.style.chart.zoom.highlightColor,
          max: I.value,
          min: 0,
          valueStart: u.value.start,
          valueEnd: u.value.end,
          start: u.value.start,
          "onUpdate:start": t[1] || (t[1] = (o) => u.value.start = o),
          end: u.value.end,
          "onUpdate:end": t[2] || (t[2] = (o) => u.value.end = o),
          onReset: _e
        }, {
          "reset-action": m(({ reset: o }) => [
            x(e.$slots, "reset-action", B(X({ reset: o })), void 0, !0)
          ]),
          _: 3
        }, 8, ["background", "borderColor", "fontSize", "useResetSlot", "labelLeft", "labelRight", "textColor", "inputColor", "selectColor", "max", "valueStart", "valueEnd", "start", "end"])) : _("", !0)
      ], 4),
      K("div", {
        ref_key: "chartLegend",
        ref: ze
      }, [
        a.value.style.chart.legend.show && ye.value ? (C(), F(Ua, {
          legendSet: We.value,
          config: pa.value,
          key: `legend_${fe.value}`,
          onClickMarker: t[3] || (t[3] = ({ i: o }) => He(o))
        }, {
          item: m(({ legend: o, index: i }) => [
            K("div", {
              onClick: (c) => o.segregate(),
              style: J(`opacity:${S.value.includes(i) ? 0.5 : 1}`)
            }, Ve(o.name), 13, ll)
          ]),
          _: 1
        }, 8, ["legendSet", "config"])) : x(e.$slots, "legend", {
          key: 1,
          legend: We.value
        }, void 0, !0)
      ], 512),
      e.$slots.watermark ? (C(), q("div", tl, [
        x(e.$slots, "watermark", B(X({ isPrinting: D(Oe) || D(Pe) })), void 0, !0)
      ])) : _("", !0),
      e.$slots.source ? (C(), q("div", {
        key: 3,
        ref_key: "source",
        ref: Me,
        dir: "auto"
      }, [
        x(e.$slots, "source", {}, void 0, !0)
      ], 512)) : _("", !0),
      u.value.end - u.value.start < 200 ? (C(), F(qa, {
        key: 4,
        hideDetails: "",
        config: {
          open: r.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: a.value.style.chart.backgroundColor,
            color: a.value.style.chart.color
          },
          head: {
            backgroundColor: a.value.style.chart.backgroundColor,
            color: a.value.style.chart.color
          }
        }
      }, {
        content: m(() => [
          (C(), F(Ja, {
            key: `table_${he.value}`,
            colNames: se.value.colNames,
            head: se.value.head,
            body: se.value.body,
            config: se.value.config,
            title: `${a.value.style.chart.title.text}${a.value.style.chart.title.subtitle.text ? ` : ${a.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: t[4] || (t[4] = (o) => r.value.showTable = !1)
          }, {
            th: m(({ th: o }) => [
              K("div", { innerHTML: o }, null, 8, ol)
            ]),
            td: m(({ td: o }) => [
              Sa(Ve(o), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : _("", !0),
      a.value.userOptions.buttons.annotator && h.value.length ? (C(), F(Qa, {
        key: 5,
        parent: U.value,
        backgroundColor: a.value.style.chart.backgroundColor,
        color: a.value.style.chart.color,
        active: ne.value,
        onClose: me
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : _("", !0)
    ], 14, al));
  }
}, xl = /* @__PURE__ */ el(ul, [["__scopeId", "data-v-bf3412d9"]]);
export {
  xl as default
};
